searchNodes=[{"ref":"AccessPass.html","title":"AccessPass","type":"module","doc":"This is the main Public api and out of the box all you will use. Includes everything you need for all your authentication needs."},{"ref":"AccessPass.html#bypass_login/1","title":"AccessPass.bypass_login/1","type":"function","doc":"Logs in a user without a password. This is intended for use with other authentication methods such as Webauthn. Case insensitive username or email is used. Returns {&quot;ok&quot;: { &quot;type&quot;:&quot;TYPE&quot;, &quot;refresh_token&quot;:&quot;refresh token&quot;, &quot;refresh_expire_in&quot;: seconds, &quot;access_token&quot;:&quot;access_token&quot;, &quot;access_expire_in&quot;: seconds } } Examples AccessPass.bypass_login(%{ username: &quot;example&quot; }) {&quot;ok&quot;: { &quot;type&quot;:&quot;basic&quot;, &quot;refresh_token&quot;:&quot;MjNmYzgzNGMtMGM3MS00YTA4LTkxMWMtNDEyODU3Yzk2ZTgy&quot;, &quot;refresh_expire_in&quot;:1200, &quot;access_token&quot;:&quot;ODhhMDgzYjctZTE3OC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;, &quot;access_expire_in&quot;:600 } }"},{"ref":"AccessPass.html#change_password/3","title":"AccessPass.change_password/3","type":"function","doc":"Calling will update user password for related password_id Returns {:ok}. Examples AccessPass.change_password(&quot;ODhhMDgzYwfefdfeC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;,&quot;myNewPassword&quot;,&quot;myNewPassword&quot;) {:ok}"},{"ref":"AccessPass.html#confirm/1","title":"AccessPass.confirm/1","type":"function","doc":"Marks a user email confirmed based on the given confirm_id Returns {:ok, { &quot;type&quot;:&quot;TYPE&quot;, &quot;refresh_token&quot;:&quot;refresh token&quot;, &quot;refresh_expire_in&quot;: seconds, &quot;access_token&quot;:&quot;access_token&quot;, &quot;access_expire_in&quot;: seconds }}. Examples AccessPass.confirm(&quot;ODhhMDgzYwfefdfeC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;) {:ok, &quot;email confirmed&quot;}"},{"ref":"AccessPass.html#forgot_username/1","title":"AccessPass.forgot_username/1","type":"function","doc":"calling will send a forgot_username email to the email(if it exists in system) Returns {ok: &quot;sent email with related username&quot;}. Examples AccessPass.forgot_username(&quot;myemail@gmail.com&quot;) {ok: &quot;sent email with related username&quot;}"},{"ref":"AccessPass.html#logged?/1","title":"AccessPass.logged?/1","type":"function","doc":"Checks if the given access token is not revoked or expired and returns the data stored for it Returns {:ok,{user: &quot;data&quot;}}. Examples AccessPass.logged?(&quot;ODhhMDgzYjctZTE3OC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;) {:ok, {username: &quot;jordiee&quot;}}"},{"ref":"AccessPass.html#login/2","title":"AccessPass.login/2","type":"function","doc":"Logs in a user. Case insensitive username or email can be used along with password. Returns {&quot;ok&quot;: { &quot;type&quot;:&quot;TYPE&quot;, &quot;refresh_token&quot;:&quot;refresh token&quot;, &quot;refresh_expire_in&quot;: seconds, &quot;access_token&quot;:&quot;access_token&quot;, &quot;access_expire_in&quot;: seconds } } Examples AccessPass.login(%{ username: &quot;example&quot;, password: &quot;otherexample&quot;, }) {&quot;ok&quot;: { &quot;type&quot;:&quot;basic&quot;, &quot;refresh_token&quot;:&quot;MjNmYzgzNGMtMGM3MS00YTA4LTkxMWMtNDEyODU3Yzk2ZTgy&quot;, &quot;refresh_expire_in&quot;:1200, &quot;access_token&quot;:&quot;ODhhMDgzYjctZTE3OC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;, &quot;access_expire_in&quot;:600 } }"},{"ref":"AccessPass.html#logout/1","title":"AccessPass.logout/1","type":"function","doc":"calling logout will revoke both access_token and refresh_token for the given access_token Returns {:ok}. Examples AccessPass.logout(&quot;ODhhMDgzYwfefdfeC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;) {:ok}"},{"ref":"AccessPass.html#refresh/1","title":"AccessPass.refresh/1","type":"function","doc":"Refresh for a new access_token given a refresh_token Returns {:ok,&quot;access_token&quot;}. Examples AccessPass.refresh(&quot;ODhhMDgzYwfefdfeC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;) {:ok, &quot;ODhhMDgzYjctZTE3OC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;}"},{"ref":"AccessPass.html#register/1","title":"AccessPass.register/1","type":"function","doc":"Register a new user Returns {&quot;ok&quot;: { &quot;type&quot;:&quot;TYPE&quot;, &quot;refresh_token&quot;:&quot;refresh token&quot;, &quot;refresh_expire_in&quot;: seconds, &quot;access_token&quot;:&quot;access_token&quot;, &quot;access_expire_in&quot;: seconds } } Examples AccessPass.register(%{ username: &quot;example&quot;, password: &quot;otherexample&quot;, password_confirm: &quot;otherexample&quot;, email: &quot;example@email.com&quot;, meta: { coolInfo: &quot;stored in here&quot; } }) {&quot;ok&quot;: { &quot;type&quot;:&quot;basic&quot;, &quot;refresh_token&quot;:&quot;MjNmYzgzNGMtMGM3MS00YTA4LTkxMWMtNDEyODU3Yzk2ZTgy&quot;, &quot;refresh_expire_in&quot;:1200, &quot;access_token&quot;:&quot;ODhhMDgzYjctZTE3OC00YjgyLWFiZGMtZTJjOWZiMzJjODhi&quot;, &quot;access_expire_in&quot;:600 } }"},{"ref":"AccessPass.html#reset_password/1","title":"AccessPass.reset_password/1","type":"function","doc":"calling will set a reset password email to the linked email account of the username Returns {ok: &quot;password reset sent to accounts email&quot;}. Examples AccessPass.reset_password(&quot;jordiee&quot;) {ok: &quot;password reset sent to accounts email&quot;}"},{"ref":"AccessPass.Auth.html","title":"AccessPass.Auth","type":"module","doc":"Plug that checks for access-token in header and then checks if its expired or revoked. If it&#39;s not expired/revoked it adds the stored data from the token in meta. If it is then it returns 401 unauthorized and halts the plug by default. Can be changed. You can pass confirmed: true on the plug to only auth if the users email has been confirmed."},{"ref":"AccessPass.Auth.html#call/2","title":"AccessPass.Auth.call/2","type":"function","doc":""},{"ref":"AccessPass.Auth.html#init/1","title":"AccessPass.Auth.init/1","type":"function","doc":""},{"ref":"AccessPass.AuthExtended.html","title":"AccessPass.AuthExtended","type":"module","doc":"Plug that checks for access-token in header and then checks if its expired or revoked. If it&#39;s not expired/revoked it adds the stored data from the token in meta. If it is then it returns 401 unauthorized and halts the plug by default. Can be changed. You can pass any number of arguments in keyword list format to match against the users meta obj that is stored on registration. An example use case is for role based auth."},{"ref":"AccessPass.AuthExtended.html#call/2","title":"AccessPass.AuthExtended.call/2","type":"function","doc":""},{"ref":"AccessPass.AuthExtended.html#init/1","title":"AccessPass.AuthExtended.init/1","type":"function","doc":""},{"ref":"AccessPass.Routes.html","title":"AccessPass.Routes","type":"module","doc":"Routes provides a drop in macro to generate routes for a phoenix route file to handle the following endpoints: GET /check GET /refresh POST /register POST /confirm POST /login POST /reset_password POST /logout POST /change_password POST /forgot_username usage: defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes scope &quot;/&quot; do get &quot;/&quot;, PageController, :index access_pass :routes end end"},{"ref":"AccessPass.Routes.html#access_pass/1","title":"AccessPass.Routes.access_pass/1","type":"macro","doc":""},{"ref":"AccessPassBehavior.html","title":"AccessPassBehavior","type":"behaviour","doc":"This Module provides you the ability to override AccessPass behavior Create a new module in your application and impliment any of the callbacks below to override default behavior. EX. defmodule MyApplication do use AccessPassBehavior # all of your overrides here end # in your config file config :access_pass, overrides_module: MyApplication"},{"ref":"AccessPassBehavior.html#c:after_confirm/1","title":"AccessPassBehavior.after_confirm/1","type":"callback","doc":"This function is called after a user has confirmed their email address and must return {:ok} Returns {:ok}."},{"ref":"AccessPassBehavior.html#c:after_insert/1","title":"AccessPassBehavior.after_insert/1","type":"callback","doc":"This function is called after a user registration insert happens and must return the same object that is passed in. Returns %AccessPass.Users{} that was passed in"},{"ref":"AccessPassBehavior.html#c:after_login/1","title":"AccessPassBehavior.after_login/1","type":"callback","doc":"This function is called after_login and should return a map that will be stored in the users token Returns {:ok,%{custom: true}}"},{"ref":"AccessPassBehavior.html#c:auth_error/1","title":"AccessPassBehavior.auth_error/1","type":"callback","doc":"This is used to override what is returned for auth error when email is not confirmed. This function should call plug send_resp and halt the plug. You can set your own status code / return override here. Returns conn."},{"ref":"AccessPassBehavior.html#c:auth_error/1","title":"AccessPassBehavior.auth_error/1","type":"callback","doc":"This is used to override what is returned for auth error when email is not confirmed. This function should call plug send_resp and halt the plug. You can set your own status code / return override here. Returns conn."},{"ref":"AccessPassBehavior.html#c:confirmation_email/0","title":"AccessPassBehavior.confirmation_email/0","type":"callback","doc":"This function should return text:html for the confirmation_email email, look at Email Templating section in Crash Course section of the docs for more info. Returns &lt;p&gt;Email text is returned&lt;/p&gt;."},{"ref":"AccessPassBehavior.html#c:custom_user_changes/1","title":"AccessPassBehavior.custom_user_changes/1","type":"callback","doc":"This function is called before registration insert, you can add additional data to the changeset and must return the altered changeset Returns altered %Ecto.Changeset{} struct"},{"ref":"AccessPassBehavior.html#c:forgot_username/0","title":"AccessPassBehavior.forgot_username/0","type":"callback","doc":"This function should return text:html for the forgot_username email, look at Email Templating section in Crash Course section of the docs for more info. Returns &lt;p&gt;Email text is returned&lt;/p&gt;."},{"ref":"AccessPassBehavior.html#c:gen_user_id/1","title":"AccessPassBehavior.gen_user_id/1","type":"callback","doc":"This function is used to change the default user_id generation. It must return the passed in changeset and a string used for user id in a tuple. Returns {%Ecto.Changeset{}, String.t()}."},{"ref":"AccessPassBehavior.html#c:insert_override/2","title":"AccessPassBehavior.insert_override/2","type":"callback","doc":"This function is called as a replacement to Repo.insert and must run the insert op for the given changeset. It also passes the origional register params unaltered in case you want to add additional fields. It should return the return of Repo.insert Returns {:ok, %AccessPass.Users{}} | {:error, %AccessPass.Users{}}"},{"ref":"AccessPassBehavior.html#c:login_return/2","title":"AccessPassBehavior.login_return/2","type":"callback","doc":"This function is passed a map of tokens and the user struct. What is returned will be forwarded along and returned by register/login Returns %{ &quot;type&quot;: &quot;basic&quot;, &quot;refresh_token&quot;: &quot;OTc1Nzk5MTQtN2Y4Ny00MDI1LTk1YjgtNzA3OWNmN2Q3M2Iy&quot;, &quot;refresh_expire_in&quot;: 0, &quot;access_token&quot;: &quot;ZDU1YjM2NGQtNTgyMi00OTRmLTgxYzItNTc5M2JiODNiYzAz&quot;, &quot;access_expire_in&quot;: 300, &quot;extra_param&quot;: &quot;this is extra&quot; }."},{"ref":"AccessPassBehavior.html#c:password_reset/0","title":"AccessPassBehavior.password_reset/0","type":"callback","doc":"This function should return text:html for the password reset email, look at Email Templating section in Crash Course section of the docs for more info. Returns &lt;p&gt;Email text is returned&lt;/p&gt;."},{"ref":"introduction.html","title":"Introduction","type":"extras","doc":"Introduction AccessPass is an out of the box solution to api authentication. While AccessPass is quite opinionated in how everything works it still offers configuration options such as email templating. AccessPass in a way was inspired by elixir&#39;s addict but to be more focused on api authentication. AccessPass does NOT provide any UI views so when using it AccessPass will handle the api calls for login/logout/register ect but the form sending that data is separated from AccessPass What is the authentication type? AccessPass uses the idea of access tokens and refresh tokens. Access tokens out of the box last 5 minutes while refresh tokens last forever(both configurable). AccessPass handles internally expiring tokens and provides for the ability to refresh for new tokens. AccessPass access/refresh tokens are not actually tokens but merely ids used to look up a authorization. Unlike normal token based authentication you can revoke tokens at any time to prevent access while the implementation remains fast by hitting a GenServer and not a database. Can it work across servers? AccessPass Supports distributed enviroments via the distributed and flag. Read more about them in the config section. By default access pass uses ETS for token tracking but if distributed flag is true it will start replicating all inserts/delete calls to connected nodes. This is a for on &quot;weak distribution&quot; in the sense that newly joined nodes do not copy the current ets state from another node and if net split happens data may be lost on rejoin causing users to have to relog. Each node is responsible on token insert for revoking the token after the set expiration period, that way if network goes down after token is replicated the token will still get revoked at the correct time. Replicated ETS was choses over mnesia because mnesia is very hard to make a general solution to just &quot;work&quot; for all node structures. What does it do? When using AccessPass you get the following done for you: You get implementations for logging a user in and out, user registration including the sending of confirmation emails,forgot password and forgot username. It includes a plug implementation that will check if a user is authorized based on header values. It also includes a macro to generate all the routes for you if you are using phoenix. Requirements AccessPass requires the use of postgres and a users table that matches the following migration: defmodule YourApplication do use Ecto.Migration def change do create table(:users) do add :user_id, :string add :username, :string, size: 20 add :meta, :map add :email, :string add :password_hash, :string add :successful_login_attempts, :integer add :confirm_id, :string add :password_reset_key, :string add :password_reset_expire, :integer add :confirmed, :boolean timestamps end create unique_index(:users, [:email]) create unique_index(:users, [:user_id]) create unique_index(:users, [:username]) end end"},{"ref":"getting_started.html","title":"Getting Started","type":"extras","doc":"Getting Started The idea behind AccessPass was to have a very quick setup and have a full implementation of authorization.(2 lines of code minus configs) Installation add the following to your deps: {:access_pass, &quot;~&gt; 0.6.1&quot;} Before running mix deps.get please add the configuration below. Configuration Through the rest of the documentation I will be showing examples for using AccessPass with phoenix but that is NOT required. AccessPass can be used with plain plug and does not have a phoenix dependency. First we need to make sure you have the basic configs required. At minimum you need to have a bamboo email adaptor set and an ecto repo configured like follows. Go here for more information on bamboo adapters. config :access_pass, AccessPass.Mailer, adapter: Bamboo.SendgridAdapter, api_key: &quot;SG.yoursendgridkey&quot; config :access_pass, repo: Test.Repo, from: &quot;SENDINGEMAIL@whatever.com&quot; The above configuration is assuming your application already has a ecto repo. if not use the following: config :access_pass, AccessPass.Mailer, adapter: Bamboo.SendgridAdapter, api_key: &quot;SG.yoursendgridkey&quot; config :access_pass, from: &quot;SENDINGEMAIL@whatever.com&quot; config :access_pass, :ecto_repos, [AccessPass.Repo] config :access_pass, AccessPass.Repo,[ adapter: Ecto.Adapters.Postgres, username: &quot;YOURUSERNAME&quot;, password: &quot;YOURPASSWORD&quot;, database: &quot;YOURDATABASE&quot;, hostname: &quot;YOURHOST&quot;, pool_size: 10 ] by using the above config AccessPass will start and supervise a Ecto.Repo for you. In most cases you will use the first option as you will probably be using phoenix that already has Ecto. For more info on configurations for ecto go here There are far more configuration options. You can see all options in the configuration portion of crash course Database migration AccessPass requires a user table set up exactly as the migration below. Look at the link above if you need help with migrations. defmodule YourApplication do use Ecto.Migration def change do create table(:users) do add :user_id, :string add :username, :string, size: 20 add :meta, :map add :email, :string add :password_hash, :string add :successful_login_attempts, :integer add :confirm_id, :string add :password_reset_key, :string add :password_reset_expire, :integer add :confirmed, :boolean timestamps end create unique_index(:users, [:email]) create unique_index(:users, [:user_id]) create unique_index(:users, [:username]) end end Phoenix Routes AccessPass was created to be very easy to use in a new or existing project after the initial configuration/db changes. defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes scope &quot;/&quot; do get &quot;/&quot;, PageController, :index access_pass :routes end end IMPORTANT: access_pass :routes needs to be called in global scope to work: scope &quot;/&quot; do access_pass :routes end NOT scope &quot;/&quot;, TestWeb do access_pass :routes end The above will add endpoints for: GET /check GET /refresh POST /register POST /confirm POST /login POST /reset_password POST /logout POST /change_password POST /forgot_username For more information on the above routes jump ahead to Phoenix routes section of crash course. An example of how to add authentication to an existing route is as follows: defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes pipeline :auth do plug Auth #Auth is an AccessPass plug to require auth on routes end scope &quot;/admin&quot; do pipe_through :auth #will run auth on every route in this block get &quot;/&quot;, PageController, :index end end The above will authorize all routes in the /admin block by access-token in header. To learn more jump ahead to plugs section of crash course."},{"ref":"configuration_options.html","title":"Configuration Options","type":"extras","doc":"Configuration Options overrides_module: Module that impliments AccessPassBehavior to offer customization of email templates and many other hooks. repo: used to point to an already existing repo for ecto distributed: a boolean that will decide on if data should be replicated to other connected nodes. refresh_expire_in: time in seconds to expire each refresh token access_expire_in: time in seconds to expire access token id_len: number of characters in default id generation phoneix: boolean if you are running accesspass in phoenix. It will set @derive {Phoenix.Param, key: :user_id} if true from: email address mailgun will be using to send emails. confirmation_subject: string to override confirmation subject line of email. reset_password_subject: string to override reset password subject line of email. forgot_username_subject: string to override forgot username subject line of email. bamboo email configs: look here for the configs needed. These configs go under config :access_pass, AccessPass.Mailer base_url: base URL to use for email templates. ecto configurations: If you want AccessPass to house your instance of Ecto as compared to providing repo: above then check out the getting started section for an example config. #Example configuration with every option config :access_pass, AccessPass.Mailer, adapter: Bamboo.PICKANDADAPTER, #Please look at the configs from bamboo hex page for what the required configs are. config :access_pass, repo: Test.Repo, phoenix: true, distributed: true, sync: true, #Required if already using ecto mailgun_domain: &quot;https://api.mailgun.net/v3/YOURDOMAIN&quot;, #Required mailgun_key: &quot;key-YOURKEY&quot;, #Required from: YOUREMAIL@example.com, #Required confirmation_template: {Test.Temps, :conf_template, []}, #check Email Templating password_reset_template: {Test.Temps, :reset_template, []}, #check Email Templating forgot_username_template: {Test.Temp, :forgot_user_template, []},#check Email Templating id_gen_mod: Test.Gen, #Needs to have gen_user_id(changeset) and return {changeset, ID} custom_change_mod: Test.Gen, #Needs to have custom(changeset) and return changeset insert_override_mod: Test.Gen, #Needs to have insert_override(changeset) and return {:ok, changeset} or {:error, changeset} after_insert_mod: Test.Gen, #Needs to have after_insert({:error,cs} OR {:ok,cs}) and return changeset refresh_expire_in: 3600, #(1hour) defaults to 0(no expire) access_expire_in: 600, #(10 minutes) defaults to 300(5 minutes) id_len: 12, # defaults to 6 confirmation_subject: &quot;welcome to my site&quot;, # default: &quot;Confirmation email&quot; reset_password_subject: &quot;please reset password&quot;, # default: &quot;Reset your password&quot; forgot_username_subject: &quot;woops you forgot this&quot;, # default: &quot;Forgot Username&quot; base_url: &quot;https://mydomain.example.com&quot;, # default: &quot;https://api.example.com&quot;, used in email templates"},{"ref":"phoenix_routes_helper.html","title":"Phoenix routes","type":"extras","doc":"Phoenix routes AccessPass comes with a helper module to generate authentication routes for you like the following. defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes #helper module scope &quot;/&quot; do access_pass :routes #macro to generate routes end end This will generate the following routes GET /check This endpoint is used to check if an access token is expired or as a quick way to get the json stored for the token Required Params headers: access-token GET /refresh This endpoint is used to get a new access_token with a given refresh_token(this is not expired or revoked) Required Params headers: refresh-token POST /register This endpoint is used to register a new user Required Params body: { &quot;username&quot;: &quot;username&quot;, &quot;password&quot;: &quot;password&quot;, &quot;password_confirm&quot;: &quot;password&quot; &quot;email&quot; : &quot;email&quot;, &quot;meta&quot; : {} } Returns: {&quot;ok&quot;: {&quot;type&quot;:&quot;basic&quot;, &quot;refresh_token&quot;:&quot;MzU0NjgxM2MtMzE3ZC00YmJmLWJiMDQtZmFhM2Q3Y2RhMzQ4&quot;, &quot;refresh_expire_in&quot;0, &quot;access_token&quot;:&quot;Y2ZkNjZlMDQtYWY1MS00YzhiLTgwNDgtYmRmYjg1ODcyZTFh&quot;, &quot;access_expire_in&quot;:300} } username,password and email are required. Meta is an optional object to store any data for the user. This object will be what is stored with a users access_token POST /confirm This endpoint is used to mark a user account confirmed. Will be linked to in the confirmation email sent out so you can think of this as the callback to that email. Required Params body: { &quot;confirm_id&quot;: &quot;ID that ties this confirmation to the account&quot;, } POST /login This endpoint handles user login. Required Params body: { &quot;username&quot;: &quot;username or email case insensitive&quot;, &quot;password&quot;: &quot;password&quot; } Returns: {&quot;ok&quot;: {&quot;type&quot;:&quot;basic&quot;, &quot;refresh_token&quot;:&quot;MzU0NjgxM2MtMzE3ZC00YmJmLWJiMDQtZmFhM2Q3Y2RhMzQ4&quot;, &quot;refresh_expire_in&quot;0, &quot;access_token&quot;:&quot;Y2ZkNjZlMDQtYWY1MS00YzhiLTgwNDgtYmRmYjg1ODcyZTFh&quot;, &quot;access_expire_in&quot;:300} } POST /reset_password This endpoint will send a password reset email to an email linked to a username. If no account is found it still returns ok so people can not use this endpoint to fish usernames. Required Params body: { &quot;username&quot;: &quot;username&quot; } POST /logout This endpoint is used to revoke both access and refresh token for this session. In effect logging the user out. Required Params headers: access-token POST /change_password This endpoint is used as the callback to a password reset. The flow is as follows. Request password reset |&gt; Email to form to make new password(link contains password_id |&gt; On form submit send password_id and new password to this endpoint. password resets expire 2 hours after sent. Required Params body: { &quot;password_id&quot;: &quot;passwordid&quot;, &quot;password_confirm&quot;:&quot;the new password to be set for a user&quot; &quot;new_password&quot;: &quot;the new password to be set for a user&quot; } POST /forgot_username This endpoint is used to have a user&#39;s forgotten username emailed to them. Required Params body: { &quot;email&quot; : &quot;email&quot;, } Returns: {&quot;ok&quot;: &quot;An email has been sent to you with your username&quot;}"},{"ref":"email_template.html","title":"Email Templating","type":"extras","doc":"Email Templating AccessPass sends 3 different type of emails for you. Confirmation email after a new user registration, password reset email and forgot username email. Out of the box is uses a very basic html for each. AccessPass allows you to override each of those emails by using the AccessPassBehavior. Look at the AccessPassBehavior module docs for more details. The html returned by your functions will go through EEx to swap for needed information. Below will show you the required EEx keys. confirmation template required: &lt;%= conf_key %&gt; optional: &lt;%= base_url %&gt; example: defmodule Test.Temps use AccessPassBehavior def confirmation_email() do &quot;&quot;&quot; &lt;a href=&quot;https://&lt;%= base_url %&gt;?con_key=&lt;%= conf_key %&gt;&quot;&gt;&lt;/a&gt; &quot;&quot;&quot; end end password reset template required: &lt;%= password_key %&gt; optional: &lt;%= base_url %&gt; example: defmodule Test.Temps use AccessPassBehavior def password_reset() do &quot;&quot;&quot; &lt;a href=&quot;https://&lt;%= base_url %&gt;/reset?con_key=&lt;%= password_key %&gt;&quot;&gt;&lt;/a&gt; &quot;&quot;&quot; end end forgot username template required: &lt;%= user_name %&gt; example: defmodule Test.Temps use AccessPassBehavior def forgot_username() do &quot;&quot;&quot; &lt;h1&gt; Your username is &lt;%= user_name %&gt;!&lt;/h1&gt; &quot;&quot;&quot; end end"},{"ref":"plugs.html","title":"Plugs","type":"extras","doc":"Plugs AccessPass provides a plugs to use in your router pipelines or elsewhere to authenticate users. If authenticated it will set a data object(user_id, username, email, email_confirmed,meta) on the connection for you to use downstream. If the access-token is expired it will return a 401 unauthorized Auth Auth plug is provided by use AccessPass.Routes and provides basic auth for routes. You can pass confirmed: true in order to also require a users email to be confirmed for a route. Example: defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes pipeline :auth do plug Auth #just does token check or plug Auth, confirmed: true #also requires email confirmation end scope &quot;/admin&quot; do pipe_through :auth #will run auth on every route in this block get &quot;/&quot;, PageController, :index end end In the previous if you went to yourdomain.com/admin/ it would check your header for an access-token and if found make sure its not revoked and valid. If it is it will set data object on the connection. If not it will return 401 and halt the connection. AuthExtended AuthExtended plug is provided by use AccessPass.Routes and provides extended auth capabilities. You can pass a keyword list of any length to validate stuff set in the users meta object on registration. An example is to provide role based authentication. Example: defmodule TestWeb.Router do use TestWeb, :router use AccessPass.Routes pipeline :auth do plug AuthExtended, role: &quot;admin&quot; # validate that role of admin set in meta object. plug Auth, confirmed: true # you can also combine with basic auth for email confirmation validation. end scope &quot;/admin&quot; do pipe_through :auth #will run auth on every route in this block get &quot;/&quot;, PageController, :index end end In the previous if you went to yourdomain.com/admin/ it would check your header for an access-token. If the token is found then it will validate that the users meta object currently stored has a key of role and a value of &quot;admin&quot;. If this is true then it will run basic auth for email confirmation. If this is all correct then it will store the user info in data object for use downstream."}]